program listes;

type
   list	= Nil | Cons of integer * list;

var
   l :  list;

function mult(l	:  list) : integer;
begin
   case l of
     Nil : mult := 1;
   | Cons(0, _): mult := 0;
   | Cons(x, r): mult := x * mult(r);
   end;
end;

function length(g :  list) : integer;
begin 
    case l of
      Nil    : 
	    length := 0;
      | Cons (_, Nil):
            length := 1;
      | Cons (_, r):
            length := length(r) + 1;
    end;
end;

function l123 : list;
begin
   l123 := Cons (1, Cons (2, Cons (3, Nil)));
end; { l123 }

function append(l1, l2 :  list) : list;
begin
   case l1 of
     Nil : append := l2;
   | Cons(x, r): append := Cons(x, append(r, l2));
   end;
end;

function reverse(l :  list) : list;
begin
   case l of
     Nil : reverse := Nil;
   | Cons(x,r): reverse := append(reverse(r), Cons(x, Nil));
   end;
end;

function rev_append(l1, l2 :  list) : list;
begin
   case l1 of
     Nil : rev_append := l2;
   | Cons(x,r): rev_append := rev_append(r, Cons(x, l2));
   end;
end;

function reverse2(l :  list) : list;
begin
   reverse2 := rev_append(l, Nil);
end;

procedure print(l :  list);
begin
   case l of
     Nil : ;
   | Cons(i, r): writeln(i); print(r);
   end; { case }
end;

begin
   l := l123;
   print(l);
   print(reverse(l));
   print(reverse2(l));
   writeln(mult(l));
   l := append(l, Cons(0, l));
   print(l);
   writeln(mult(l));
end
.
